/*
 * Vertice.java
 *
 * Created on 14 listopad 2003, 11:00
 */

package AGR;
import java.awt.*;
import java.util.*;
/**
 *
 * @author  x
 */
public   class Vertex implements java.io.Serializable  {
    public static int nextFreeId=0;
    public Vertex() {
        setX(0);
        setY(0);
        next = 0;
        id = 0;
        name = "";
        edges = null;
        setValue(0);
        m_vars= new Hashtable();
    }
    
    Color col;
    protected int value;
    protected float x;
    protected float y;
    public int next;
    protected int id;
    public String name;
    Hashtable m_vars;
    //public java.util.List edges = new java.util.LinkedList();
    public int edges[];// = new java.util.LinkedList();
    
    /**
     * @param n numer nodu do ktrego si czy krawd
     */
    public void addEdge(int n) {
        if ( edges == null )
            edges = new int[]{n};
        else {
            int nedgs[] = new int[edges.length+1];
            System.arraycopy(edges, 0, nedgs, 0, edges.length);
            nedgs[nedgs.length-1]=n;
            edges=nedgs;
        }
    }
    
    public String toString() {
        
        return "["+getId()+"]\n";
    }
    
    public int getId() {
        return this.id;
    }
    
    public void setId(final int id) {
        nextFreeId = Math.max(nextFreeId+1,id+1);
        this.id = id;
        //System.out.println("id = "+id+" nextFreeId = "+nextFreeId);
    }
    
    public float getX() {
        return this.x;
    }
    
    public void setX(final float x) {
        this.x = x;
    }
    
    public float getY() {
        return this.y;
    }
    
    public void setY(final float y) {
        this.y = y;
    }
    
    public static int getNextFreeId() {
        return Vertex.nextFreeId;
    }
    
    
    public int getValue() {
        return this.value;
    }
    
    public void setValue(final int value) {
        if ( value == 1 )
            col = Color.green;
        //else
        //if ( value == -1 )
        //  col = Color.green;
        else
            col = Color.yellow;
        this.value = value;
    }
    
    public Color getCol() {
        return this.col;
    }
    
    public void setCol(final Color col) {
        this.col = col;
    }
    
    public String getStringVar(String nodeVar) {
        if ( m_vars.containsKey(nodeVar) ) {
            return (String)m_vars.get(nodeVar);
        }
        return null;
    }
    
    /**
     * returns old value
     */
    public String setStringVar(String nodeVar,String newValue) {
        return (String)m_vars.put(nodeVar, newValue);
    }
    
    public String getVarsAsString() {
        StringBuffer out = new StringBuffer();
        Enumeration en = m_vars.keys();
        while(en.hasMoreElements()) {
            String key = (String)en.nextElement();
            out.append(key + "=" + (String)m_vars.get(key)+";");
        }
        return out.toString();
    }
    
    public float getFloatVar(String var) {
        String val = getStringVar(var);
        if ( val == null )
            return 0;
        else{
            try {
                return Float.parseFloat(val);
            }
            catch(NumberFormatException e) {
                e.printStackTrace();
            }
        }
        return 0;
    }
    
    public void setFloatVar(String var,float val) {
        String newVal=null;
        try {
            newVal = String.valueOf(val);
        }
        catch(NumberFormatException e) {
            e.printStackTrace();
        }
        setStringVar(var, newVal);
    }
    
    protected boolean setVertexHashVars(String nodeVars) {
        String t1,t2;
        m_vars = new Hashtable();
        StringTokenizer stok = new StringTokenizer(nodeVars,";");
        while(stok.hasMoreTokens()) {
            t1=stok.nextToken();
            StringTokenizer stok2 = new StringTokenizer(t1,"=");
            if (stok2.hasMoreElements() == false) return false;
            t1 = stok2.nextToken();
            if (stok2.hasMoreElements() == false) return false;
            t2 = stok2.nextToken();
            if (stok2.hasMoreElements()) return false;
            m_vars.put(t1,t2);
        }
        return true;
    }
}
