/*
 * BFS.java
 *
 * Created on 5 grudzie 2003, 10:11
 */

package AGR.plugins;
import AGR.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author  x
 */
public class AddNode implements Plugin {
    
    Graph m_graph;
    boolean m_finished;
    /** Creates a new instance of BFS */
    public AddNode() {
        m_finished=true;
    }
    
    public void start(Graph graph, final Vertex startVert) {
        m_graph = graph;
        m_finished=false;
        
        try{
            int arr[] = graph.saveGD0ToArray();//pobie tablice
            
            int arr2[] = new int[arr.length+3]; //dodaj do niej jeden wierzchoek i krawd
            System.arraycopy(arr, 0, arr2, 0, arr.length);
            arr2[arr2.length-3]=graph.numberOfVerticies()+1;
            arr2[arr2.length-2]=1;
            arr2[arr2.length-1]=graph.numberOfVerticies()==0 ? 1 : graph.numberOfVerticies();
            
            String vars[] = graph.getVertexVars();            
            String newVars[] = new String[vars.length+1];            
            System.arraycopy(vars, 0, newVars, 0,  vars.length);
            newVars[graph.numberOfVerticies()]  = "p="+(graph.numberOfVerticies()+1);
            
            graph.loadGD0FromArray(arr2); //zapisz now tablice
            graph.setVertexVars(newVars);
        }
        catch(IOException e)
        {e.printStackTrace();}
        
        m_finished=true;
        MainWindow.printToConsole("\nSample add node - done");
    }
    
    public void makeStep() {
        
    }
    
    
    public String toString() {
        return "Add node - sample";
    }
    
    public void setStartStep() {
        m_finished=true;
    }
    
    public boolean isFinished() {
        return m_finished;
    }
    public void incStep() {
    }
    public void decStep() {
    }
    public boolean canDoForward() {
        return false;
    }
    public boolean canDoBackward() {
        return false;
    }
    public boolean canPause() {
        return false;
    }
    
}


