/*
 * BFS.java
 *
 * Created on 5 grudzie 2003, 10:11
 */

package AGR.plugins;
import AGR.*;
import java.util.*;

/**
 *
 * @author  x
 */
public class TransitiveClosure implements Plugin {
    
    Graph m_graph;        
    boolean m_finished;
    /** Creates a new instance of BFS */
    public TransitiveClosure() {
        m_finished=true;
    }
    
    public void start(Graph graph, final Vertex startVert) {
        m_graph = graph;
        m_finished=false;
        
        int matRep[][]=graph.getMatrixRepresentation();
                
        for (int y = 0; y < matRep.length; y++)
            for (int x = 0; x < matRep.length; x++)
                if (matRep[x][y]==1)
                    for (int j=0; j < matRep.length; j++)
                        if (matRep[y][j]==1)
                            matRep[x][j]=1;
        
        m_graph.applyNewMatrixRepresentation(matRep);
        m_finished=true;
        MainWindow.printToConsole("\nTransitive closure done");
    }
    
    public void makeStep() {
        
    }
    
    
    public String toString() {
        return "Transitive closure";
    }
    
    public void setStartStep() {
        m_finished=true;
    }
    
    public boolean isFinished() {
        return m_finished;
    }
    public void incStep() {
    }
    public void decStep() {
    }
    public boolean canDoForward() {
        return false;
    }
    public boolean canDoBackward() {
        return false;
    }
    public boolean canPause() {
        return false;
    }
    
}


