/*
 * BFS.java
 *
 * Created on 5 grudzie 2003, 10:11
 */

package AGR.plugins;
import AGR.*;
import java.util.*;

/**
 *
 * @author  x
 */
public class Transpose implements Plugin {
    
    Graph m_graph;
    LinkedList m_queue = new LinkedList();
    int m_stepCount;
    int m_currentStepCount;
    boolean m_finished;
    /** Creates a new instance of BFS */
    public Transpose()
    {      
        m_finished=true;
    }
    
    public void start(Graph graph, final Vertex startVert) {
        m_graph = graph;
        m_finished=false;
        
        int matRep[][]=graph.getMatrixRepresentation();
        
                
        for (int y = 0; y < matRep.length; y++)
        {
            for (int x = y; x < matRep[y].length; x++)
            {
                int tmp=matRep[y][x];
                matRep[y][x]=matRep[x][y];    
                matRep[x][y]=tmp;
            }            
        }
        m_graph.applyNewMatrixRepresentation(matRep);
        m_finished=true;
        MainWindow.printToConsole("\nTransposition done");
    }
    
    public void makeStep() {
        
    }
        

    public String toString()
    {
        return "Transpose";
    }
    
    public void setStartStep()
    {
        m_finished=true;
    }        
    
    public boolean isFinished()
    {
        return m_finished;
    }
    public void incStep()
    {
        m_stepCount++;
    }
    public void decStep()
    {
        if (m_stepCount>1)
            m_stepCount--;
    }
     public boolean canDoForward()
    {
        return false;
    }
    public boolean canDoBackward()
    {
        return false;
    }
    public boolean canPause()
    {
        return false;
    }

}


